




//
//  main.swift
//  Kommentare für den Code
//
//  Created by Holger Hinzberg on 16.09.15.
//  Copyright © 2015 Holger Hinzberg. All rights reserved.
//

import Foundation



enum CalculationError : ErrorType
{
    case DivideByZero
    case SomethingWrong
    case OtherError
}

/**
Eine Funktion, die eine Division ausführt
- parameters:
   - Int:divident
   - Int:divisor
- throws: DivideByZero wenn durch null geteilt werden soll
- returns: Wert des Quotienten / Ergebnis der Division

- note: Eine Notiz
- copyright: Holger Hinzberg
- seealso: Zusätzliche Informationen

Beispiel
---

     do
     {
         let i = try divide(10, divisor: 5)
     }
     catch
     {
         print("Fehler!")
     }

Für eine vollständige Dokumentation
[hier](http://www.cocoa-coding.de/) kicken

*/
func divide(divident:Int, divisor:Int) throws -> Int
{
    guard divisor > 0 else
    {
        throw CalculationError.DivideByZero
    }
    return divident / divisor
}

// MARK: Methoden zu Initialisierung
// MARK: -


// TODO: Auswertungen sollten schneller sein!
// FIXME: Berechnungen stimmen nicht!




