//
//  GeometryCalculatorTests.swift
//  GeometryCalculatorTests
//
//  Created by Holger Hinzberg on 01.11.15.
//  Copyright © 2015 Holger Hinzberg. All rights reserved.
//

import XCTest

class GeometryCalculatorTests: XCTestCase {
    
    var calculator:GeometryCalculator?
    
    override func setUp()
    {
        super.setUp()
        self.calculator = GeometryCalculator()
        XCTAssertNotNil(self.calculator, "Die Instanz wurde nicht erzeugt")
    }
    
    
    override func tearDown() {
        // Put teardown code here. This method is called after the invocation of each test method in the class.
        super.tearDown()
    }
    
    func testExample()
    {
        let area = calculator?.calculateRectangleArea(
            length: 15.2, width: 22.5)
        XCTAssertEqualWithAccuracy(area!, 342,
            accuracy: 0.0001, "Die Fläche wird falsch berechnet")
        
        let volume = calculator?.calculateQubicVolume(
            length: 28.8, width: 32.3, height: 45.4)
        XCTAssertEqualWithAccuracy(volume!, 42232.896,
            accuracy: 0.0001, "Das Volumen wird falsch berechnet")
    }
  
    func testNegativeParameters()
    {
        var area = self.calculator?.calculateRectangleArea(
            length: 33.0, width: -11.1)
        XCTAssertEqual(area, 0, "Der Rückgabewert ist nicht 0")
        
        area = self.calculator?.calculateRectangleArea(
            length: -1.0, width: 1.1)
        XCTAssertEqual(area, 0, "Der Rückgabewert ist nicht 0")
        
        var volume = self.calculator?.calculateQubicVolume(
            length: -7.8, width: 67.8, height: 2.3)
        XCTAssertEqual(volume, 0, "Der Rückgabewert ist nicht 0")
    
        volume = self.calculator?.calculateQubicVolume(
            length: 23.1, width: -27.8, height: 2.3)
        XCTAssertEqual(volume, 0, "Der Rückgabewert ist nicht 0")
       
        volume = self.calculator?.calculateQubicVolume(
            length: -2.1, width: 7.2, height: -2.8)
        XCTAssertEqual(volume, 0, "Der Rückgabewert ist nicht 0")
    }
    
    func testPerformanceExample() {
        // This is an example of a performance test case.
        self.measureBlock {
            // Put the code you want to measure the time of here.
        }
    }
    
}
